from tkinter import *
from threeD import *

def flatShading(canvas, a,L0, ca, v0):
    pp=[0 for i in range(len(a.p))]
    for i in range(len(a.p)):#　screen座標系への変換
        pp[i]=screen(a.p[i])
    V = unit(a.p[0]-v0)                         #視線ベクトル
    L = unit(a.p[0]-L0)                         #照明ベクトル
    N = unit((a.p[0]-a.p[2]) %(a.p[1]-a.p[3]))  #法線ベクトル
    C = shading(V, L, N, ca).toString()         #描画色
    Num=len(a.p); n=Num-1
    RR=rangeScreen(pp, Num)
    y_min=RR[0]; y_max=RR[1]
    s=[0,0,0,0]; s[0]=RR[2]; s[1]=RR[3]
    for y in range(int(y_min), int(y_max+1)):
        s = setSID(pp, s, n, y)
        p0=pp[s[0]]; p1=pp[s[1]]; p2=pp[s[2]]; p3=pp[s[3]]
        p4 = interPos(p1, p2, y) #p1,p2を補間
        p5 = interPos(p0, p3, y) #p0,p3を補間
        for x in range(int(p4.x), int(p5.x+1)):
            p=interpolate(p4,p5,int(float(x)-p4.x), int(p5.x-float(x)))
            if z_buff[x][y]<=p.z: #以前描画した画素より手前にあれば描画
                drawPointXY(canvas, x,y,C)
                z_buff[x][y]=p.z 
        
#■メインプログラム
root= Tk()
root.title("3D Methods(flat shading)")
canvas=Canvas(root,width=500,height=400)
canvas.pack()
z_buff=[[-1e30 for j in range(400)] for i in range(500)]
init2D(500,400)
origin(250,200)
V0= Point(500,500,500)                  #視点
L0= Point(0,500,1000)                   #照明光
setview(V0)
#drawAxisXYZ(canvas)
#b=circle_xy(36)                         #円形(補助線用)
a=circle_xz(18)                         #ドーナツ形の生成
aa=a*50
Fig=revolve_z(move(100,0,0)*aa,36)      #原点から100離れた円を回転
Num=len(Fig.polygon)
for i in range(Num):
    flatShading(canvas,Fig.polygon[i],L0, Color(0x77, 0x77, 0xFF),V0)
a=circle_xz(18,0,180)                   #球体の生成
Fig=move(0,0,50)*revolve_z(a*70,36)     #円を回転して球を作成
Num=len(Fig.polygon)
for i in range(Num):
     flatShading(canvas,Fig.polygon[i],L0, Color(0xFF,0x77, 0xFF),V0)
#a=circle_xz(18);aa=a*50
#drawLine(canvas, move(100,0,0)*aa, 'red')
#drawLine(canvas, b*150, 'red')
